#ifndef FOLDERUTILS_H
#define FOLDERUTILS_H

#include <iostream>
#include <string>
#include <sys/types.h>
#include <dirent.h>
#include <stdio.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <vector>

using namespace std;

class Disc;

class Folder{
 public:
  Folder();
  ~Folder();
  Folder(char *_path);
  Folder *getChild(int i);
  void addChild(Folder *newChild);
  Folder *getParent();
  void fillModel(GtkTreeModel *model);
  double diskUsage();
  double getForlderSize();
  int buildTree(const char* dirName);
  string getName();
  void setName(string _name);
  string getPath();
  void setPath(string _path);
  string getListPath();
  void setListPath(string _path);  
  string getBurnPath();
  void setBurnPath(string _path);  
  int getDepth(Folder *fParent);
  int getDepth();
  void assignToDisc(Disc *aDisc);
  void assignToNone();
  void updateAssignment(Disc *aDisc);
  Disc *assignedDisc;
  Folder *fParent;
  vector<Folder*> children;
  string folderName;
  string folderPath;
  string listPath;
  string burnPath;
  GtkTreeIter iter;
  GtkTreeIter iter2;
  double folderSize;
  bool bSelected;
  int toggleSelectionState(bool _state, bool _force);

};

class FolderView{
 public:
  FolderView(GtkTreeView *tree_view_folder);
  ~FolderView();

  GtkCellRenderer *check_renderer;
  GtkCellRenderer *discimage_renderer;
  GtkCellRenderer *discassign_renderer;
  GtkCellRenderer *folderimage_renderer;
  GtkCellRenderer *folder_renderer;

  GtkTreeViewColumn *check_column;
  GtkTreeViewColumn *discimage_column; 
  GtkTreeViewColumn *discassign_column;
  GtkTreeViewColumn *folderimage_column;
  GtkTreeViewColumn *folder_column;
      
  GtkTreeView *tree_view;
  GtkTreeModel *model;
  GtkTreeSelection *selection;
  vector<Folder*> flatFolderList;
  void applyModel();
  void createFlatList(Folder *curDir);
  Folder *findIter(GtkTreeIter _iter);
  Folder *findPath(string _path);
  void folderToggleEvent(char *user_data);
};

void toggle_event(GtkCellRendererToggle *cellrenderertoggle, gchar *arg1, gpointer user_data);

#endif
