#include "newprojectdialog.h"
#include <sys/stat.h>
#include "project.h"
#include "notadirdialog.h"

extern Project *project;

FileDialog* newprojectdialog(){
  FileDialog* newprojectdialog = new FileDialog();
  newprojectdialog->createDialog("Select Project Root Folder", false);
  newprojectdialog->connectSignal(newprojectdialog->cancel_button, 
				   "clicked", G_CALLBACK(fbutton_delete));
  newprojectdialog->connectSignal(newprojectdialog->ok_button, 
				  "clicked", G_CALLBACK(on_newproject_ok_clicked));
  newprojectdialog->showDialog();
  return newprojectdialog;
}


void on_newproject_ok_clicked (GtkButton *button, gpointer user_data){
  GtkWidget *newdia = ((FileDialog*)user_data)->filedialog;
  string dirname = (char*)gtk_file_selection_get_filename((GtkFileSelection*)newdia);
  
  struct stat buf;
  if((stat(dirname.c_str(), &buf)) != 0){
    notadirdialog();
    return;
  }
  else{
    if(!S_ISDIR(buf.st_mode)){
      notadirdialog();
      return;
    }
  }
  
  if(project){
    delete project;
  }  
  
  project = new Project();
  project->newProject((char*)dirname.c_str());
  
  delete (FileDialog*)user_data;
}
