#ifndef PROCESS_H
#define PROCESS_H

#include <gtk/gtk.h>
#include <string>
#include <iostream>
#include <vector>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <signal.h>
#include <sys/wait.h>
#include <stdio.h>
#include <fcntl.h>

using namespace std;
gboolean read_input(GIOChannel *source, GIOCondition condition, gpointer data);
gint my_s_pipe(gint fd[2]);

class Process{
 public:
  bool processDone;
  bool bUseCallback;
  GIOChannel* io_out;
  GIOChannel* io_in;
  GIOChannel* io_err;
  guint iotag_in;
  guint iotag_err;
  guint iotag_out;
  pid_t pid;
  int offset;
  int linenum;
  int rValue;
  GtkTextIter iter;
  GtkTextIter iterold;
  GtkTextBuffer* textbuffer;
  GtkTextView* textview;
  gint out;
  gint in;
  gint err;
  string path;
  string command;
  vector<string> sArguments;
  Process();
  void setGtkTextItems(GtkTextBuffer* _textbuffer, GtkTextView* _textview);
  void setPath(string _path);
  void setCommand(string _command);
  void setCallbackState(bool);
  void addArgument(string arg);
  void clearArguments();
  int spawnProcess();
  int checkProcess();
  int closeProcess();
  int waitProcess();
  int killProcess();
  void resetProcess();
  int processInput(GIOChannel *source);
  char **buildArguments();
  char *buildArgumentList();
  void freeArguments(char **_arguments);
  void setupProcessIO();
  void setupProcessCB();
};

#endif
