#include "renamefolderdialog.h"
#include "project.h"
#include "discutils.h"

extern Project *project;

RenameFolder::RenameFolder(string fname){
  foldername = fname;
}

RenameFolder::~RenameFolder(){
  gtk_widget_destroy(renamefolderdialog);
}

void RenameFolder::createDialog(){
  renamefolderdialog = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (renamefolderdialog), "Rename Folder");
  gtk_window_set_position (GTK_WINDOW (renamefolderdialog), GTK_WIN_POS_MOUSE);
  gtk_window_set_resizable (GTK_WINDOW (renamefolderdialog), FALSE);

  dialog_vbox = GTK_DIALOG (renamefolderdialog)->vbox;
  gtk_widget_show (dialog_vbox);

  top_vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (top_vbox);
  gtk_box_pack_start (GTK_BOX (dialog_vbox), top_vbox, TRUE, TRUE, 0);

  top_hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (top_hbox);
  gtk_box_pack_start (GTK_BOX (top_vbox), top_hbox, FALSE, FALSE, 0);

  folderimage = gtk_image_new_from_stock ("gtk-open", GTK_ICON_SIZE_DIALOG);
  gtk_widget_show (folderimage);
  gtk_box_pack_start (GTK_BOX (top_hbox), folderimage, TRUE, TRUE, 0);

  string tmpStr = " " + foldername + " ";
  renamefolder_label = gtk_label_new (tmpStr.c_str());
  gtk_widget_show (renamefolder_label);
  gtk_box_pack_start (GTK_BOX (top_hbox), renamefolder_label, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (renamefolder_label), GTK_JUSTIFY_LEFT);

  renamefolder_entry = gtk_entry_new ();
  gtk_entry_set_text(GTK_ENTRY(renamefolder_entry), foldername.c_str());
  gtk_widget_show (renamefolder_entry);
  gtk_box_pack_start (GTK_BOX (top_vbox), renamefolder_entry, FALSE, FALSE, 0);

  dialog_action_area = GTK_DIALOG (renamefolderdialog)->action_area;
  gtk_widget_show (dialog_action_area);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area), GTK_BUTTONBOX_SPREAD);

  cancelbutton = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (cancelbutton);
  gtk_dialog_add_action_widget (GTK_DIALOG (renamefolderdialog), cancelbutton, GTK_RESPONSE_CANCEL);

  okbutton = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (okbutton);
  gtk_dialog_add_action_widget (GTK_DIALOG (renamefolderdialog), okbutton, GTK_RESPONSE_OK);
  gtk_widget_grab_focus(okbutton);

  g_signal_connect ((gpointer) renamefolderdialog, "delete_event",
		    G_CALLBACK (on_rename_delete_clicked),this);
  g_signal_connect ((gpointer) cancelbutton, "clicked",
                    G_CALLBACK (on_rename_cancel_clicked),this);
  g_signal_connect ((gpointer) okbutton, "clicked",
                    G_CALLBACK (on_rename_ok_clicked),this);
}

void RenameFolder::showDialog(){
  gtk_widget_show(renamefolderdialog);
}

RenameFolder* renamefolderdialog(string fname){
  RenameFolder* rnfdia = new RenameFolder(fname);
  rnfdia->createDialog();
  rnfdia->showDialog();
  return rnfdia;
}

void on_rename_cancel_clicked(GtkButton *button, gpointer user_data){
  delete (RenameFolder*)user_data;
}

void on_rename_ok_clicked(GtkButton *button, gpointer user_data){
  GtkWidget *rnfentry = ((RenameFolder*)user_data)->renamefolder_entry;
  string tmpStr = gtk_entry_get_text(GTK_ENTRY(rnfentry));
  project->discView->renameSelected(tmpStr);
  delete (RenameFolder*)user_data;
}

void on_rename_delete_clicked(GtkWidget *dialog, GdkEvent *event, gpointer user_data){
  delete (RenameFolder*)user_data;
}
